DBCC FREEPROCCACHE;
SET STATISTICS IO ON;


SELECT CU.CustomerID
	,PP.LastName
	,PH.PhoneNumber	
	,SUM(SD.OrderQty * SD.UnitPrice) AS Retail
FROM Sales.Customer CU ,Person.Person PP, Sales.Store ST
		,Person.PersonPhone PH,  Sales.SalesOrderHeader SH
		,Sales.SalesOrderDetail SD
WHERE SH.DueDate > '2004-05-13'
		AND PP.BusinessEntityID = CU.PersonID	
		AND ST.BusinessEntityID = CU.StoreID
		AND PH.BusinessEntityID = PP.BusinessEntityID
		AND SH.CustomerID = CU.CustomerID
		AND SD.SalesOrderID = SH.SalesOrderID
GROUP BY CU.CustomerID ,PP.LastName ,PH.PhoneNumber;


SELECT CU.CustomerID
	,PP.LastName
	,PH.PhoneNumber
	,SUM(SD.OrderQty * SD.UnitPrice) AS Retail
	FROM Sales.Customer CU
	INNER JOIN Person.Person PP
		ON PP.BusinessEntityID = CU.PersonID	
	INNER JOIN Sales.Store ST
		ON ST.BusinessEntityID = CU.StoreID
	Inner JOIN Person.PersonPhone PH
		ON PH.BusinessEntityID = PP.BusinessEntityID
	INNER JOIN Sales.SalesOrderHeader SH
		ON SH.CustomerID = CU.CustomerID
--		AND SH.DueDate > '2004-05-13'
	INNER JOIN Sales.SalesOrderDetail SD
		ON SD.SalesOrderID = SH.SalesOrderID
	WHERE SH.DueDate > '2004-05-13'
	GROUP BY CU.CustomerID, PP.LastName, PH.PhoneNumber;


--Criteria IN WHERE rather than JOIN 
--Doesn't matter

		
SELECT CU.CustomerID
	,PP.LastName
	,PH.PhoneNumber
	,SUM(SD.OrderQty * SD.UnitPrice) AS Retail
FROM Sales.Customer CU
	INNER JOIN Person.Person PP
		ON PP.BusinessEntityID = CU.PersonID	
	INNER JOIN Sales.Store ST
		ON ST.BusinessEntityID = CU.StoreID
	INNER JOIN Person.PersonPhone PH
		ON PH.BusinessEntityID = PP.BusinessEntityID
	INNER JOIN Sales.SalesOrderHeader SH
		ON SH.CustomerID = CU.CustomerID
		-- AND SH.DueDate > '2004-05-13'
	INNER JOIN Sales.SalesOrderDetail SD
		ON SD.SalesOrderID = SH.SalesOrderID
WHERE SH.DueDate > '2004-05-13'
GROUP BY CU.CustomerID ,PP.LastName ,PH.PhoneNumber;


		
/* Notes

Not a difference in the query plan. 

Big difference in readability.

Easier to dissect and troubleshoot.

Missing index is due to AdventureWorks database scheme.  Straight out of the box

*/