-- From Grant Fritchey's Performance Tuning Distilled
-- Great book!
--
-- DMV's

SELECT  *
FROM    sys.dm_os_performance_counters AS dopc ;






SELECT  *
FROM    sys.dm_exec_requests AS der 






SELECT  *
FROM    sys.dm_exec_query_stats AS deqs ;






SELECT * FROM Sales.SalesOrderHeader


SELECT  dest.[text]
       ,deqs.execution_count
       ,deqs.last_elapsed_time
       ,deqs.max_elapsed_time
FROM    sys.dm_exec_query_stats AS deqs
        CROSS APPLY sys.dm_exec_sql_text(deqs.sql_handle) AS dest
WHERE   dest.[text] LIKE 'SELECT * FROM Sales.SalesOrderHeader%' ;





--
-- Execution Plans

SELECT  p.FirstName + ' ' + p.LastName AS PersonName
       ,p.Title
       ,a.City
       ,a.PostalCode
FROM    Person.Person AS p
        JOIN Person.BusinessEntityAddress AS bea
        ON p.BusinessEntityID = bea.BusinessEntityID
        JOIN Person.Address AS a
        ON bea.AddressID = a.AddressID
WHERE   p.LastName LIKE 'Re%' ;





--key lookup
SELECT  sod.ProductID
       ,sod.OrderQty
       ,sod.UnitPrice
FROM    Sales.SalesOrderDetail AS sod
WHERE   sod.ProductID = 897 ;






IF EXISTS ( SELECT  *
            FROM    sys.indexes
            WHERE   object_id = OBJECT_ID(N'[Sales].[SalesOrderDetail]')
                    AND name = N'ix_SalesOrderDetail_ProductID' ) 
    DROP INDEX [ix_SalesOrderDetail_ProductID] ON [Sales].[SalesOrderDetail] WITH ( ONLINE = OFF )
GO

CREATE  NONCLUSTERED INDEX [ix_SalesOrderDetail_ProductID] ON [Sales].[SalesOrderDetail] ([ProductId] ASC)
INCLUDE (OrderQty,UnitPrice)
ON  [PRIMARY]
GO



-- Statistics
UPDATE STATISTICS Production.WorkOrder ;

SELECT  *
FROM    Production.WorkOrder AS wo
WHERE   wo.ProductID = 515 ;


ALTER DATABASE AdventureWorks2014 SET AUTO_UPDATE_STATISTICS OFF

BEGIN TRANSACTION
SELECT TOP 10000
        IDENTITY( INT,5,1 ) AS n
INTO    #nums
FROM    [master].dbo.SysColumns sc1
       ,MASTER.dbo.SysColumns sc2 ;

INSERT  INTO Production.WorkOrder
        (ProductID
        ,OrderQty
        ,ScrappedQty
        ,StartDate
        ,EndDate
        ,DueDate
        ,ScrapReasonID
        ,ModifiedDate)
        SELECT  515
               ,2
               ,4
               ,GETDATE()
               ,GETDATE()
               ,GETDATE()
               ,2
               ,GETDATE()
        FROM    #nums AS n

SELECT  *
FROM    Production.WorkOrder AS wo
WHERE   wo.ProductID = 515 ;


ROLLBACK TRANSACTION

ALTER DATABASE AdventureWorks2014 SET AUTO_UPDATE_STATISTICS ON
UPDATE STATISTICS Production.WorkOrder






--Recompiles

IF ( SELECT OBJECT_ID('dbo.p1')
   ) IS NOT NULL 
    DROP PROC dbo.p1
GO
CREATE PROC dbo.p1
AS 
    CREATE TABLE #t1 ( c1 INT ) ;
    INSERT  INTO #t1
            ( c1 )
    VALUES  ( 42 ) ;
GO


EXEC dbo.p1;





-- Query structure
--#1 of 3
SELECT  soh.SalesOrderID
FROM    Sales.SalesOrderHeader AS soh
WHERE   LEFT(soh.SalesOrderNumber, 4) = 'SO62' ;



SELECT  soh.SalesOrderID
FROM    Sales.SalesOrderHeader AS soh
WHERE   soh.SalesOrderNumber LIKE 'SO62%' ;


--#2 of 3
SELECT  pm.ProductModelID
       ,pm.[Name]
FROM    Production.ProductModel AS pm
WHERE   UPPER(pm.[Name]) = 'HL ROAD FRAME'


SELECT  pm.ProductModelID
       ,pm.[Name]
FROM    Production.ProductModel AS pm
WHERE   UPPER('hl road frame') = pm.[Name]




--#3 of 3
SELECT  *
FROM    Purchasing.PurchaseOrderHeader AS poh
WHERE   poh.PurchaseOrderID * 2 = 3400



SELECT  *
FROM    Purchasing.PurchaseOrderHeader AS poh WITH ( INDEX ( PK_PurchaseOrderHeader_PurchaseOrderID ) )
WHERE   poh.PurchaseOrderID * 2 = 3400





SELECT *
FROM Purchasing.PurchaseOrderHeader poh
WHERE PurchaseOrderID = 3400/2





--Blocking

IF(SELECT OBJECT_ID('dbo.t1')) IS NOT NULL
DROP TABLE dbo.t1;
GO
CREATE TABLE dbo.t1(c1 INT);
INSERT INTO dbo.t1 VALUES (1);
GO

BEGIN TRAN
DELETE dbo.t1 WHERE c1 = 1;
SELECT tl.request_session_id
,tl.resource_database_id
,tl.resource_associated_entity_id
,tl.resource_type
,tl.resource_description
,tl.request_mode
,tl.request_status
FROM sys.dm_tran_locks tl;
ROLLBACK
