/*
Execution Related DMV
Server Scope
Returns information about the cursors that are open in various databases. 
*/

SELECT c.session_id
	,se.nt_domain
	,se.nt_user_name
	,se.[program_name]
	,c.reads
	,c.writes
	,c.creation_time
	,c.fetch_status
	,c.is_open
	,c.name
	,SUBSTRING(s.text, (c.statement_start_offset/2)+1, 
        ((CASE c.statement_end_offset
          WHEN -1 THEN DATALENGTH(s.text)
         ELSE c.statement_end_offset
         END - c.statement_start_offset)/2) + 1) AS statement_text
FROM sys.dm_exec_cursors(58) AS c
	CROSS APPLY sys.dm_exec_sql_text(c.sql_handle) AS s
	INNER JOIN sys.dm_exec_sessions AS se ON se.session_id = c.session_id;