-- Buffer space consumption by object & index.sql
-- break down buffers by object (table, index)
-- Note that object names are only available in the current database
-- Switch to a different database to see object names for that database
SELECT b.database_id, 
	Database_Name = CASE 
		b.database_id 
		WHEN 32767 THEN 'Resource'
        ELSE db_name(b.database_id) 
		END, 
    p.object_id,
    Object_Name = object_name(p.object_id),
    p.index_id,
    buffer_count=count(*) 
FROM sys.allocation_units a
        JOIN sys.dm_os_buffer_descriptors b
            ON a.allocation_unit_id = b.allocation_unit_id
        JOIN sys.partitions p
            ON a.container_id = p.hobt_id WHERE object_id > 99 GROUP 
BY b.database_id,p.object_id, p.index_id 
ORDER BY buffer_count DESC
