/*
General performance related on 64 bit servers

Run this query in all application related databases.  
It retrieves the total cache size in MB, particularly interested in "TokenAndPermUserStore" entry

(KB 92736) if size is greater than 200MB flush cache using DBCC FREESYSTEMCACHE ('TokenAndPermUserStore')
*/
SELECT [name], SUM(single_pages_kb + multi_pages_kb)/1024.0 AS TotalMB
FROM sys.dm_os_memory_clerks
GROUP BY [name]
ORDER BY TotalMB DESC, [name] ASC;