-- DBCC IND useful in SQL Server 2008 and earlier

-- A small table will only return a few rows
DBCC IND (pubs, authors, -1)


-- A large table will return LOTS of rows, one row for every 
-- page of every index, and one row for each page of 
-- special storage formats
DBCC IND (AdventureWorks2012, 'Sales.SalesOrderHeader', -1)

-- It's hard to visually scan almost 1000 rows of output to 
-- find the information of interest



-- SQL Server 2012 gives us a METADATA FUNCTION!

use pubs
SELECT allocated_page_file_id as PageFID, allocated_page_page_id as PagePID, object_id as ObjectID, partition_id AS PartitionID, allocation_unit_type_desc as AU_type, page_type as PageType
FROM sys.dm_db_database_page_allocations(db_id('pubs'), object_id('authors'), null, null, 'DETAILED')



SELECT allocated_page_file_id as PageFID, allocated_page_page_id as PagePID, object_id as ObjectID, partition_id AS PartitionID, allocation_unit_type_desc as AU_type, page_type as PageType
FROM sys.dm_db_database_page_allocations(db_id('AdventureWorks2012'), object_id('Sales.SalesOrderHeader'), null, null, 'DETAILED')
