--Switch to AdventureWorks
use AdventureWorks2008R2
GO
/*Turn on Trace Flag 3604 so DBCC PAGE OUTPUT shows on the screen.*/
dbcc traceon (3604)
/*Get the list of pages for the table*/
dbcc ind ('AdventureWorks2008R2', 'HumanResources.Employee', 1)
/*View the header page
DBCC PAGE (Database, FileId, PageId, OutputFormat) {IAM page}

Output Format
    0 - print just the page header
    1 - page header plus per-row hex dumps and a dump of the page slot array (unless its a page that doesn't have one, like allocation bitmaps)
    2 - page header plus whole page hex dump
    3 - page header plus detailed per-row interpretation

*/

/*View a data page {Data Page Page}
The slot array can be found at the bottom of the page.
*/
DBCC PAGE (AdventureWorks2008R2, 1, 3817, 3)

/*
Here's what the slot array looks like.  We can see it by changing the output type of DBCC PAGE
from 3 to 1.

Row - Offset                        
42 (0x2a) - 7745 (0x1e41)           
41 (0x29) - 7563 (0x1d8b)           
40 (0x28) - 7379 (0x1cd3)           
39 (0x27) - 7199 (0x1c1f)           
38 (0x26) - 7021 (0x1b6d)           
37 (0x25) - 6839 (0x1ab7)           
36 (0x24) - 6653 (0x19fd)           
35 (0x23) - 6475 (0x194b)           
34 (0x22) - 6291 (0x1893)           
33 (0x21) - 6105 (0x17d9)           
32 (0x20) - 5925 (0x1725)           
31 (0x1f) - 5742 (0x166e)           
30 (0x1e) - 5560 (0x15b8)           
29 (0x1d) - 5378 (0x1502)           
28 (0x1c) - 5192 (0x1448)           
27 (0x1b) - 5010 (0x1392)           
26 (0x1a) - 4826 (0x12da)           
25 (0x19) - 4642 (0x1222)           
24 (0x18) - 4457 (0x1169)           
23 (0x17) - 4277 (0x10b5)           
22 (0x16) - 4095 (0xfff)            
21 (0x15) - 3909 (0xf45)            
20 (0x14) - 3733 (0xe95)            
19 (0x13) - 3551 (0xddf)            
18 (0x12) - 3373 (0xd2d)            
17 (0x11) - 3187 (0xc73)            
16 (0x10) - 3003 (0xbbb)            
15 (0xf) - 2824 (0xb08)             
14 (0xe) - 2644 (0xa54)             
13 (0xd) - 2464 (0x9a0)             
12 (0xc) - 2286 (0x8ee)             
11 (0xb) - 2100 (0x834)             
10 (0xa) - 1920 (0x780)             
9 (0x9) - 1736 (0x6c8)              
8 (0x8) - 1553 (0x611)              
7 (0x7) - 1369 (0x559)              
6 (0x6) - 1191 (0x4a7)              
5 (0x5) - 1009 (0x3f1)              
4 (0x4) - 823 (0x337)               
3 (0x3) - 639 (0x27f)               
2 (0x2) - 457 (0x1c9)               
1 (0x1) - 277 (0x115)               
0 (0x0) - 96 (0x60)                 

*/