/*
For deadlocking, I have 2 steps Deadlock Demo 1 & Deadlock Demo 2

P1 consists of two steps:
  Step 1 is call step 2
  Step 2 is below:
*/

-- Step 1

SET NOCOUNT ON;

IF OBJECT_ID('dbo.LockTable1', 'u') is null
CREATE TABLE dbo.LockTable1
(LockTable1ID int identity(1,1) primary key clustered
,Acolumn int not null
);

IF OBJECT_ID('dbo.LockTable2', 'u') is null
CREATE TABLE dbo.LockTable2
(LockTable2ID int identity(1,1) primary key clustered
,Acolumn int not null
);

BEGIN TRANSACTION LockPart1;

      INSERT INTO LockTable1 VALUES (1);
      UPDATE LockTable1 WITH (TABLOCK) SET Acolumn = 2

      WAITFOR DELAY '00:00:20';

      INSERT INTO LockTable2 VALUES (2);
      UPDATE LockTable2 WITH (TABLOCK) SET Acolumn = 5

COMMIT TRANSACTION LockPart1;

-- Step 2 has one step. Execute from separate SSMS query window.

SET NOCOUNT ON;

IF OBJECT_ID('dbo.LockTable1', 'u') IS NULL
CREATE TABLE dbo.LockTable1
(LockTable1ID INT IDENTITY(1,1) PRIMARY KEY CLUSTERED
,Acolumn INT NOT NULL
);

IF OBJECT_ID('dbo.LockTable2', 'u') IS NULL
CREATE TABLE dbo.LockTable2
(LockTable2ID INT IDENTITY(1,1) PRIMARY KEY CLUSTERED
,Acolumn INT NOT NULL
);

BEGIN TRANSACTION LockPart2;

      INSERT INTO LockTable2 VALUES (2);
      UPDATE LockTable2 WITH (TABLOCK) SET Acolumn = 5

      WAITFOR DELAY '00:00:10';

      INSERT INTO LockTable1 VALUES (1);
      UPDATE LockTable1 WITH (TABLOCK) SET Acolumn = 2

COMMIT TRANSACTION LockPart2;

DROP TABLE dbo.LockTable1;
DROP TABLE dbo.LockTable2;