-- string functions

-- FORMAT
SELECT FORMAT(CURRENT_TIMESTAMP, 'yyyy-MM') AS year_month;

-- CONCAT
DECLARE @Names AS TABLE (first_name VARCHAR(35), last_name VARCHAR(35));

INSERT INTO @Names (first_name, last_name)
VALUES('Joe', 'Doe'), ('Jane', NULL);

SELECT CONCAT(first_name, ' ', last_name) AS full_name
FROM @Names;

-- logical functions

-- CHOOSE
SELECT CHOOSE(2, 'first', 'second', 'third') AS element;

-- IIF
SELECT IIF(1 < 2, 'true', 'false') AS result;

-- conversion functions

-- PARSE
SELECT PARSE('Saturday, 24 September 2011' AS DATETIME2 USING 'en-US') AS us_date;

-- TRY_PARSE
SELECT TRY_PARSE('a' AS DECIMAL(10, 2)) AS dec1, TRY_PARSE('1.1' AS DECIMAL(10, 2)) AS dec2;

SELECT IIF(TRY_PARSE('a' AS DECIMAL(10, 2)) IS NULL, 'not a valid decimal', 'valid decimal') AS result;

-- TRY_CONVERT
SELECT TRY_CONVERT(DECIMAL(10, 2), 'a') AS dec1, TRY_CONVERT(DECIMAL(10, 2), '1.1') AS dec2;

-- date and time functions

--DATEFROMPARTS
SELECT DATEFROMPARTS(2011, 9, 24) AS date_value;

--DATETIME2FROMPARTS
SELECT DATETIME2FROMPARTS(2011, 9, 24, 23, 59, 59, 10, 2) AS date_value;

--DATETIMEFROMPARTS
SELECT DATETIME2FROMPARTS(2011, 9, 24, 23, 59, 59, 0, 0) AS date_value;

--DATETIMEOFFSETFROMPARTS
SELECT DATETIMEOFFSETFROMPARTS(2011, 9, 24, 14, 23, 23, 0, 12, 0, 7) AS date_value;

--SMALLDATETIMEFROMPARTS
SELECT SMALLDATETIMEFROMPARTS(2011, 9, 24, 23, 59) AS date_value;

--TIMEFROMPARTS
SELECT TIMEFROMPARTS(23, 59, 59, 7, 2) AS time_value;

--EOMONTH
SELECT EOMONTH('2011-09-24') AS end_of_month;
SELECT EOMONTH('2011-09-24', -2) AS end_of_month_two_months_ago;



