IF OBJECT_ID ('dbo.CustomerAddresses') IS NOT NULL DROP TABLE dbo.CustomerAddresses
GO

SELECT AddressID, AddressLine1, City, PostalCode AS ZipCode, StateProvinceCode AS State
	INTO dbo.CustomerAddresses
FROM Person.Address address
	INNER JOIN Person.StateProvince state 
		ON address.StateProvinceID = state.StateProvinceID
GO

INSERT INTO dbo.CustomerAddresses 
	SELECT * FROM dbo.CustomerAddresses WHERE ZipCode = '98168';
GO 5

CREATE NONCLUSTERED INDEX idx1 ON dbo.CustomerAddresses (State);
CREATE NONCLUSTERED INDEX idx2 ON dbo.CustomerAddresses (ZipCode);
GO


SELECT * FROM dbo.CustomerAddresses 
WHERE State = 'WA' AND ZipCode = '98168';
GO
SELECT * FROM dbo.CustomerAddresses WITH (INDEX = idx1, INDEX = idx2)
WHERE State = 'WA' AND ZipCode = '98168';
GO
