CREATE PROCEDURE CalculateSales
AS
 
 SELECT sale_month, sale_amount
 FROM (VALUES('2010-01', 120.50),
             ('2010-02', 214.00),
			 ('2010-03', 109.10)) AS T(sale_month, sale_amount);

 SELECT SUM(sale_amount) AS total_sales
 FROM (VALUES('2010-01', 120.50),
             ('2010-02', 214.00),
			 ('2010-03', 109.10)) AS T(sale_month, sale_amount);

GO

SET FMTONLY ON;
EXEC CalculateSales;
SET FMTONLY OFF;

/*

sale_month sale_amount
---------- ---------------------------------------

(0 row(s) affected)

total_sales
---------------------------------------

(0 row(s) affected)

*/

GO

-- execute SP
EXEC CalculateSales;

/*

sale_month sale_amount
---------- -------------
2010-01    120.50
2010-02    214.00
2010-03    109.10

(3 row(s) affected)

total_sales
---------------------------------------
443.60

(1 row(s) affected)

*/

GO

-- use system stored procedure
EXECUTE sp_describe_first_result_set N'CalculateSales';

/*

-- abbreviated

is_hidden column_ordinal name         is_nullable system_type_id system_type_name  max_length precision scale 
--------- -------------- ------------ ----------- -------------- ----------------- ---------- --------- ----- 
0         1              sale_month   0           167            varchar(7)        7          0         0     
0         2              sale_amount  0           108            numeric(5,2)      5          5         2     


*/

-- use DMV
SELECT name, system_type_name 
FROM sys.dm_exec_describe_first_result_set(N'CalculateSales', NULL, 0);

GO

CREATE TABLE Foo (
 keycol INT NOT NULL PRIMARY KEY,
 datacol CHAR(10));

EXEC sp_describe_undeclared_parameters N'SELECT datacol FROM Foo WHERE keycol = @x';

/*

-- abbreviated

parameter_ordinal name  suggested_system_type_id suggested_system_type_name   suggested_max_length suggested_precision suggested_scale suggested_user_type_id 
----------------- ----- ------------------------ ---------------------------- -------------------- ------------------- --------------- ---------------------- 
1                 @x    56                       int                          4                    10                  0               NULL                   


*/

GO

DROP TABLE Foo;

DROP PROCEDURE CalculateSales;