CREATE PROCEDURE CalculateSales
AS
 
 SELECT sale_month, sale_amount
 FROM (VALUES('2010-01', 120.50),
             ('2010-02', 214.00),
			 ('2010-03', 109.10)) AS T(sale_month, sale_amount);

 SELECT SUM(sale_amount) AS total_sales
 FROM (VALUES('2010-01', 120.50),
             ('2010-02', 214.00),
			 ('2010-03', 109.10)) AS T(sale_month, sale_amount);

GO

EXECUTE CalculateSales;

/*

sale_month sale_amount
---------- -------------
2010-01    120.50
2010-02    214.00
2010-03    109.10

(3 row(s) affected)

total_sales
-------------
443.60

(1 row(s) affected)

*/

EXECUTE CalculateSales 
WITH RESULT SETS 
(
    (month CHAR(7), 
	 amount DECIMAL(10, 2)),

    (total DECIMAL(10, 2))
);

/*

month   amount
------- --------
2010-01 120.50
2010-02 214.00
2010-03 109.10

(3 row(s) affected)

total
--------
443.60

(1 row(s) affected)

*/

DROP PROCEDURE CalculateSales;