SELECT * 
FROM sys.dm_exec_query_optimizer_info;
GO

/*
In particular, plan_generation_num indicates the number of times 
the query has recompiled. The following sample query gives you the 
top 25 stored procedures that have been recompiled.
*/

SELECT top 25
    sql_text.text,
    sql_handle,
    plan_generation_num,
    execution_count,
    dbid,
    objectid 
FROM 
    sys.dm_exec_query_stats a
    cross apply sys.dm_exec_sql_text(sql_handle) as sql_text
WHERE 
    plan_generation_num >1
ORDER BY plan_generation_num DESC;
GO

