DECLARE @start_time DATETIME
SELECT  @start_time = GETDATE()
	
--	< any query or a script that you want to time, without a GO >
	
SELECT  Elapsed Time, sec = DATEDIFF( second, @start_time, GETDATE() ) 

GO

/* Transact-SQL test harness by Kevin Kline, http://KevinEKline.com, Twitter at kekline */

/* Flushes all dirty pages from the buffer to disk */

CHECKPOINT;

/* Flush the data cache and procedure cache, respectively. */

DBCC DROPCLEANBUFFERS;

DBCC FREEPROCCACHE;

/* Enable statistics tracking for IO and timings. Remember, SET commands remain enabled 
   during a session until disabled. */

SET STATISTICS IO ON;

SET STATISTICS TIME ON;

-- Whatever your Transact-SQL statement(s) might be.
SELECT  *
FROM    [Sales].[vIndividualCustomer]
WHERE   [BusinessEntityID] BETWEEN 6131 AND 7000;
GO


SET STATISTICS IO OFF;

SET STATISTICS TIME OFF;

/* Textual Execution Plans, if desired.

SET SHOWPLAN_TEXT ON;

SET SHOWPLAN_TEXT OFF;
 
 */




select * from Person.Address where City='Bothell'
GO
select * from Person.Address where City='Bottrop'
GO
select * from Person.Address where City='Albany'
GO
select * from Person.Address where City='Newport Hills'
GO
SELECT plan_handle, st.text
FROM sys.dm_exec_cached_plans 
CROSS APPLY sys.dm_exec_sql_text(plan_handle) AS st
WHERE text LIKE N'SELECT * FROM Person.Address%';
GO


DBCC FREESYSTEMCACHE;

SELECT   CU.CustomerID, SD.ProductID, SUM(SD.OrderQty) AS Units, SUM(SD.LineTotal) AS Cost
FROM     Sales.Customer CU
         INNER JOIN Sales.SalesOrderHeader SH
           ON SH.CustomerID = CU.CustomerID
         INNER JOIN Sales.SalesOrderDetail SD
           ON SD.SalesOrderID = SH.SalesOrderID
GROUP BY CU.CustomerID, SD.ProductID;

/*
SELECT CU.CustomerID, 
       SD.ProductID, 
       SUM(SD.OrderQty) AS Units, 
       SUM(SD.LineTotal) AS Cost 
  FROM Sales.Customer CU, 
       Sales.SalesOrderHeader SH, 
       Sales.SalesOrderDetail SD 
 WHERE SD.SalesOrderID = SH.SalesOrderID 
   AND SH.CustomerID = CU.CustomerID 
 GROUP BY CU.CustomerID, 
          SD.ProductID 
OPTION (LOOP JOIN);
*/