/*******************************************************************************
Written By: John Morehouse
Date: October 2011

THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
PARTICULAR PURPOSE.

The Reader (you) is free to modify/alter/adjust this script as needed to fit their needs. 

********************************************************************************/



/***************************************************************************
-- Transaction Isolation Levels
***************************************************************************/
USE AdventureWorks2014
GO

--Clean Up from previous demos
UPDATE Sales.SalesOrderHeader
SET Comment = NULL
GO

SELECT TOP 10 Comment, * from Sales.SalesOrderHeader
GO

BEGIN TRANSACTION
	-- reusing our code from previous demo
	UPDATE soh
	SET Comment = cust.AccountNumber + ' is the best customer EVER!'
	FROM Sales.SalesOrderHeader soh
	INNER JOIN Sales.Customer cust on soh.CustomerID = cust.CustomerID 
	WHERE soh.SalesOrderID % 2 = 0
	
GO


-- OPEN IN ANOTHER CONNECTION
USE AdventureWorks2014
GO

SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED

-- What do we see?
SELECT Comment,* FROM Sales.SalesOrderHeader
GO

--roll back transaction in other connection
ROLLBACK TRANSACTION

-- What do we see now?
SELECT Comment,* FROM Sales.SalesOrderHeader
GO




-- Look at NOLOCK

BEGIN TRANSACTION
	-- reusing our code from previous demo
	UPDATE soh
	SET Comment = cust.AccountNumber + ' is the best customer EVER!'
	FROM Sales.SalesOrderHeader soh
	INNER JOIN Sales.Customer cust on soh.CustomerID = cust.CustomerID 
	WHERE soh.SalesOrderID % 2 = 0





-- Clean Up
ROLLBACK TRANSACTION