-- The following query demonstrates this in SQL Server 2005+. 
-- It makes use of the sys.indexes and sys.tables catalog views, along with the STATS_DATE() 
-- function, to retrieve the date that each index was last updated for every user table in the 
-- current database. 
-- Original author is Joe Webb.
-- Find the last time an index statistics were updated.

SELECT
   t.name AS Table_Name
   ,i.name AS Index_Name
   ,i.type_desc AS Index_Type
   ,STATS_DATE(i.object_id,i.index_id) AS Date_Updated
FROM
   sys.indexes i JOIN
   sys.tables t ON t.object_id = i.object_id
WHERE
   i.type > 0
ORDER BY
   t.name ASC
   ,i.type_desc ASC
   ,i.name ASC;