SELECT
	  TableName = so.name
	, IndexName = si.name
	, FileGrp = sfg.groupname
	, NumRows = si.[rows]
	, UsedSpcMB = (si.used *
			CAST((SELECT low
			FROM master.dbo.spt_values d
			WHERE d.number = 1
			 AND d.type = 'E') AS bigint)
			 / 1024 / 1024)
	, ResvdSpcMB = (si.reserved *
			CAST((SELECT low
			FROM master.dbo.spt_values d
			WHERE d.number = 1
			 AND d.type = 'E') as bigint)
			 / 1024 / 1024)
FROM sysindexes si
INNER JOIN sysobjects so
  ON si.id = so.id
INNER JOIN sysfilegroups sfg
  ON si.groupid = sfg.groupid
WHERE si.indid > 0
 AND si.indid < 255
 AND so.xtype = 'U'
 AND si.status & 64 = 0
ORDER BY TableName, IndexName